package com.freshcodes.red5pro;

import android.content.Context;

import androidx.annotation.NonNull;

import com.red5pro.streaming.config.R5Configuration;

import java.util.Map;

import io.flutter.plugin.common.BinaryMessenger;
import io.flutter.plugin.common.StandardMessageCodec;
import io.flutter.plugin.platform.PlatformView;
import io.flutter.plugin.platform.PlatformViewFactory;

public class Red5StreamPlayerViewFactory extends PlatformViewFactory {
    @NonNull
    private final BinaryMessenger messenger;

    Red5StreamPlayerViewFactory(@NonNull BinaryMessenger messenger) {
        super(StandardMessageCodec.INSTANCE);
        this.messenger = messenger;
    }

    @Override
    public PlatformView create(Context context, int id, Object args) {
        final Map<String, Object> creationParams = (Map<String, Object>) args;
        Map<String, Object> configuration = (Map<String, Object>) creationParams.get("configuration");
        String licenseKey = (String) configuration.get("licenseKey");
        int protocol = (int) configuration.get("protocol");
        String host = (String) configuration.get("host");
        int port = (int) configuration.get("port");
        String contextName = (String) configuration.get("contextName");
        float bufferTime = ((Double) configuration.get("bufferTime")).floatValue();
        R5Configuration r5Configuration = new R5Configuration(AppUtility.intToR5StreamProtocol(protocol), host, port, contextName, bufferTime);
        r5Configuration.setLicenseKey(licenseKey);

        String streamName = (String) creationParams.get("streamName");

        return new Red5StreamPlayerView(context, messenger, id, r5Configuration, streamName);
    }
}
