package com.freshcodes.red5pro;

import android.content.Context;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

import java.util.Map;

import io.flutter.plugin.common.BinaryMessenger;
import io.flutter.plugin.common.StandardMessageCodec;
import io.flutter.plugin.platform.PlatformView;
import io.flutter.plugin.platform.PlatformViewFactory;

public class Red5StreamViewFactory extends PlatformViewFactory {
    @NonNull
    private final BinaryMessenger messenger;

    Red5StreamViewFactory(@NonNull BinaryMessenger messenger) {
        super(StandardMessageCodec.INSTANCE);
        this.messenger = messenger;
    }

    @NonNull
    @Override
    public PlatformView create(@NonNull Context context, int id, @Nullable Object args) {
        final Map<String, Object> creationParams = (Map<String, Object>) args;
        int height = (int) creationParams.get("height");
        int width = (int) creationParams.get("width");

        int bitrate = (int) creationParams.get("bitrate");
        int fps = (int) creationParams.get("fps");

        return new Red5StreamView(context, messenger, id, height, width, bitrate, fps);
    }
}
