//
//  Red5StreamPlayerViewFactory.m
//  red5pro
//
//  Created by Jaydip Godhani on 23/11/21.
//

#import "Red5StreamPlayerViewFactory.h"
#import "Red5StreamPlayerView.h"

@implementation Red5StreamPlayerViewFactory {
    NSObject<FlutterBinaryMessenger>* _messenger;
}


-(instancetype)initWithMessenger:(NSObject<FlutterBinaryMessenger>*)messenger {
  self = [super init];
  if (self) {
    _messenger = messenger;
  }
  return self;
}

- (NSObject<FlutterPlatformView>*)createWithFrame:(CGRect)frame
                                   viewIdentifier:(int64_t)viewId
                                        arguments:(id _Nullable)args {
    NSLog(@"Player argument : %@",args);
  return [[Red5StreamPlayerView alloc] initWithFrame:frame
                              viewIdentifier:viewId
                                   arguments:args
                             binaryMessenger:_messenger];
}
- (NSObject<FlutterMessageCodec> *)createArgsCodec {
    return [FlutterStandardMessageCodec sharedInstance];
}

@end
